\ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\ \\\\\\\\\\\\\\\\         M16C disassembler          \\\\\\\\\\\\\\\\
\ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

decimal 0 value standalone
standalone [if]
        anew mydisassembler
        : .label        ( a -- )        ." :" (.) type ;
        : >$            ( a n -- )      type ;
        : optab         ( -- )          ." __" ;
        : c>n           ( c -- n )      dup   0x80 and 0<> 0xFFFFFF80 and or ;
        : w>n           ( c -- n )      dup 0x8000 and 0<> 0xFFFF8000 and or ;
[then]

\ Uses global lookup words for displaying labels:
\ .LABEL  ( a -- )
\         Displays the address in hex, unless it can be identified.
\         Used text labels if possible.  Includes a trailing blank.

vocabulary disasmM16C
also disasmM16C definitions

    0 value opcode
0x100 value dpc
    0 value offset              \ add this to dpc to get physical address

hex
standalone [if]
create testdata 100 allot
variable *test
: homelen       ( -- )          *test @ testdata - ;
: hometest      ( -- )          testdata *test ! ;
: !test         ( c -- )        *test @ c!  1 *test +! ;
: nextbyte      ( -- c )        *test @ c@  1 *test +! ;
[else]
: nextbyte      ( -- c )        dpc offset + c@  1 +to dpc ;
[then]

8 constant      opcolumn                                \ operands print here
: optab         ( -- )          opcolumn tab>$ ;        \ tab to operand column

: wide          ( -- t )        opcode 1 and ;
: n>n           ( nibl -- n )   dup 0x8 and 0<> 0xFFFFFFF8 and or ;
: imm4>n        ( nibl -- n )   dup 0x8 and if negate 6 + then 1+ ;
: 20>n          ( 20 -- n )     dup 0x80000 and 0<> 0xFFF80000 and or ;
: split         ( byte -- lo hi ) 0x10 /mod ;
: .,            ( -- )          s" ," >$ ;
: .#            ( n -- )        s" #" >$ (.) >$ ;
: next16        ( -- n )        nextbyte nextbyte 8 lshift or ; \ little endian
: next20        ( -- n )        next16 nextbyte 0x10 lshift or ;
: nextimm       ( -- n )        wide if next16 w>n else nextbyte c>n then ;
: .abs16        ( -- )          next16 .label ;
: .abs20        ( -- )          next20 .label ;
: .imm          ( -- )          nextimm .# ;
: .imm8         ( -- )          nextbyte c>n .# ;
: .imm16        ( -- )          next16 w>n .# ;
: .num8         ( n -- )        c>n (.) >$ ;
: .num16        ( n -- )        w>n (.) >$ ;
: .disp8        ( -- )          nextbyte c>n dpc + .label ;
: .disp16       ( -- )          next16 w>n dpc + .label ;
: .disp20       ( -- )          next20  20>n dpc + .label ;
: disp3         ( opcode -- )   7 and dup 4 and if 0xFFFFFFFC or then dpc + .label ;
: .R0           ( -- )          wide if s" R0" else s" R0L" then >$ ;
: .R1,R0        ( -- )          wide if s" R1,R0" else s" R0H,R0L" then >$ ;
: .rol/roh      ( t -- )        if s" R0H" else s" R0L" then >$ ;
: .r0l          ( -- )          s" R0L" >$ ;
: .r1h          ( -- )          s" R1H" >$ ;
: .imm,sp       ( disp -- )     .# ., s" SP" >$ ;
: unknown       ( -- )          s" unknown" >$ ;
: (tab)         ( addr len -- ) >$ optab ;
: ta"           ( <string> -- ) postpone s" postpone (tab) ; immediate
: (so)          ( addr len -- ) >$ wide if s" .W" else s" .B" then >$ optab ;
: so"           ( <string> -- ) postpone s" postpone (so) ; immediate
: (sg)          ( addr len -- ) >$ wide if s" .W:G" else s" .B:G" then >$ optab ;
: sg"           ( <string> -- ) postpone s" postpone (sg) ; immediate
: (sq)          ( addr len -- ) >$ wide if s" .W:Q" else s" .B:Q" then >$ optab ;
: sq"           ( <string> -- ) postpone s" postpone (sq) ; immediate
: (disp8)       ( addr len -- ) nextbyte c>n (.) >$ >$ ;
: d8"           ( <string> -- ) postpone s" postpone (disp8) ; immediate
: (disp16)      ( addr len -- ) next16 w>n (.) >$ >$ ;
: d16"          ( <string> -- ) postpone s" postpone (disp16) ; immediate
: (disp20)      ( addr len -- ) next20     (.) >$ >$ ;
: d20"          ( <string> -- ) postpone s" postpone (disp20) ; immediate

: cond          ( cond -- ) 0x0F and  3 *
\                  0  1  2  3  4  5  6  7  8  9  a  b  c  d  e  f
                s" C  GTUZ  N  NC LEUNZ PZ LE O  GE ?  GT NO LT ?  " drop + 3
                -trailing >$ optab ;
: cond1         ( cond -- ) 0x0F and  3 *
                s" C  GTUZ  N  LE O  GE ?  NC LEUNZ PZ GT NO LT ?  " drop + 3
                -trailing >$ optab ;
: .flag         ( flag# -- ) chars s" CDZSBOIU????????" drop + 1 >$ ;
: .rdest        ( reg# -- ) 7 and 2* chars s" R0R1R2R3A0A1SBFB" drop + 2 >$ ;
: .brdest       ( reg# -- ) 3 and 3 * chars s" R0LR0HR1LR1H" drop + 3 >$ ;
: .ll           ( dir -- )  3 and 2* chars s" LLLHHLHH" drop + 2 >$ ;
: .qsrc         ( src -- ) 3 and wide if .rdest else .brdest then ;


: .mask         ( mask -- ) 8 0 \ display list of registers
        do      dup 1 and
                if i .rdest dup 1 > if s" /" >$ then then 2/
        loop    drop ;

: .sdest        ( spec_dest -- ) 7 and 5 *
                s" ---  INTBLINTBHFLG  ISP  SP   SB   FB   " drop + 5
                -trailing >$ ;

0 value operand2  \ extension bytes for a destination
: ex2           ( dest -- )  7 and
            dup 7 = if next16 to operand2 drop exit then
                4 > if nextbyte to operand2 then ;

: ex4           ( dest -- )
                2 rshift
        case    3 of next16 to operand2 endof
                2 of nextbyte to operand2 endof
        endcase ;


binary

: (dest)        ( dest -- )
        case    0000 of wide if s" R0" else s" R0L" then >$     endof
                0001 of wide if s" R1" else s" R0H" then >$     endof
                0010 of wide if s" R2" else s" R1L" then >$     endof
                0011 of wide if s" R3" else s" R1H" then >$     endof
                0100 of s" A0"                           >$     endof
                0101 of s" A1"                           >$     endof
                0110 of s" [A0]"                         >$     endof
                0111 of s" [A1]"                         >$     endof
                1000 of operand2 .num8  s" [A0]"         >$     endof
                1001 of operand2 .num8  s" [A1]"         >$     endof
                1010 of operand2 .num8  s" [SB]"         >$     endof
                1011 of operand2 .num8  s" [FB]"         >$     endof
                1100 of operand2 .num16 s" [A0]"         >$     endof
                1101 of operand2 .num16 s" [A1]"         >$     endof
                1110 of operand2 .num16 s" [SB]"         >$     endof
                1111 of operand2 .label                         endof
        endcase ;

: .dest         ( dest -- )  dup ex4 (dest) ;

: .ldest        ( dest -- )
        case    0000 of s" R2R0" >$             endof
                0001 of s" R3R1" >$             endof
                0100 of s" A1A0" >$             endof
                1100 of d20" [A0]"              endof
                1101 of d20" [A1]"              endof
                dup 101 > if dup .dest
                else    s" <bogus_dest>" >$
                then
        endcase ;

: .wdest        ( dest -- )
        case    1100 of d20" [A0]"              endof
                1101 of d20" [A1]"              endof
                dup .dest
        endcase ;

: dest3         ( dest -- ) 111 and
        case    011 of s" R0H" >$               endof
                100 of s" R0L" >$               endof
                101 of 1010 (dest)              endof
                110 of 1011 (dest)              endof
                111 of 1111 (dest)              endof
                unknown
        endcase ;

: bytedest      ( dest -- ) dup ex2 dest3 ;
: .bydest       ( -- ) opcode bytedest ;

: imm8,dest     ( -- )
                nextbyte c>n .# ., .bydest ;

: dest4         ( dest -- ) 11 and
        case    01  of 1010 .dest               endof
                10  of 1011 .dest               endof
                11  of 1111 .dest               endof
                unknown
        endcase ;

: src,dest1     ( -- ) \ dest1 src2
                opcode 111 and 100 /mod swap  ( dest1 src2 )
        case    00 of dup 0= .rol/roh           endof
                01 of d8" [SB]"                 endof
                10 of d8" [FB]"                 endof
                11 of .abs16                    endof
        endcase ., .rol/roh ;

: .imm,dest     ( dest -- )
                dup ex4 nextimm .# ., (dest) ;

: math1         ( operand -- )  \ 0111011s
                split
        case    0000 of so" TST"  .imm,dest     endof
                0001 of so" XOR"  .imm,dest     endof
                0010 of sg" AND"  .imm,dest     endof
                0011 of sg" OR"   .imm,dest     endof
                0100 of sg" ADD"  .imm,dest     endof
                0101 of so" SBC"  .imm,dest     endof
                0110 of so" ADC"  .imm,dest     endof
                0111 of so" SBB"  .imm,dest     endof
                1000 of sg" CMP"  .imm,dest     endof
                1010 of so" ROLC" .dest         endof
                1011 of so" RORC" .dest         endof
                1001 of so" DIVX" .dest         endof
                1100 of so" DIVU" .dest         endof
                1101 of so" DIV"  .dest         endof
                1110 of so" ADCF" .dest         endof
                1111 of so" ABS"  .dest         endof
                nip unknown
        endcase ;

: src,dest      ( -- )
                nextbyte split ( dest src )
                .dest ., .dest ;

: imm4,dest     ( -- )
                nextbyte split ( dest imm4 ) n>n .# .,  .dest ;

: imm41,dest    ( -- )
                nextbyte split ( dest imm4 ) imm4>n .# .,  .dest ;

: immed2        ( operand -- )  \ 01111100
        case    11100100 of so" DADD" .r1,r0            endof
                11100110 of so" DADC" .r1,r0            endof
                11101100 of so" DADD" .imm ., .r0       endof
                11101110 of so" DADC" .imm ., .r0       endof
                11101101 of so" DSUB" .imm ., .r0       endof
                11100101 of so" DSUB" .r1,r0            endof
                11100000 of so" DIVU" .imm              endof
                11100001 of so" DIV"  .imm              endof
                11100011 of so" DIVX" .imm              endof
                11101111 of so" DSBB" .imm ., .r0       endof
                11100111 of so" DSBB" .r1,r0            endof
                11101011 of sg" ADD"  nextimm .imm,sp   endof
                11110000 of ta" LDCTX" .abs16 ., .abs20 endof
                11110010 of wide if ta" EXITD" else ta" ENTER" .imm8 then endof
                11110011 of ta" EXTS.W  R0"             endof
                11100010 of sg" PUSH" .imm              endof
                11101000 of so" SMOVF"                  endof
                11101001 of so" SMOVB"                  endof
                11101010 of so" SSTR"                   endof
                11110001 of so" RMPA"                   endof
                split
                0100 of so" MULU".imm,dest              endof
                0101 of so" MUL" .imm,dest              endof
                1110 of so" DIVU".imm,dest              endof
                1101 of so" DIV" .imm,dest              endof
                0110 of ta" EXTS.B" .dest               endof
                1100 of ta" STC     PC," .ldest         endof
                100 /mod ( dest dir op )
                00 of s" MOV" >$ .ll optab .dest ., .r0l endof
                10 of s" MOV" >$ .ll optab .r0l ., .dest endof
                nip nip unknown
        endcase ;

: immed1        ( operand -- )  \ 01111101
        case    11110000 of ta" STCTX" .abs16 ., .abs20 endof
                11110011 of ta" WAIT"                   endof
                split ( imm4 op )
                1011 of sq" ADD" n>n .imm,sp            endof
                1101 of s" BM" >$ cond s" C" >$         endof
                0010 of ta" JMPI.W" .wdest              endof
                0000 of ta" JMPI.A" .ldest              endof
                0011 of ta" JSRI.W" .wdest              endof
                0001 of ta" JSRI.A" .ldest              endof
                1001 of ta" PUSHA"  .dest               endof
                1010 of ta" LDIPL" 111 and .#           endof
                1100 of s" J" >$  cond optab .disp8     endof
                10000 * + immed2 0
        endcase ;

: bit,dsp8      ( -- )
                opcode 111 and (.) >$ ., .disp8 ;

: (bdest)       ( dest -- )  -1 to opcode s" bit," >$ (dest) ;
: .bdest        ( dest -- )  -1 to opcode s" bit," >$ .dest ;

: bitop         ( operand -- )  \ 01111110
                split ( src op )
        case    0000 of ta" BTSTC"  .bdest endof
                0001 of ta" BTSTS"  .bdest endof
                0010 of  s" BM" >$ dup ex4 nextbyte cond1 (bdest) endof
                0011 of ta" BNTST"  .bdest endof
                0100 of ta" BAND"   .bdest endof
                0101 of ta" BNAND"  .bdest endof
                0110 of ta" BOR"    .bdest endof
                0111 of ta" BNOR"   .bdest endof
                1000 of ta" BCLR:G" .bdest endof
                1001 of ta" BSET:G" .bdest endof
                1010 of ta" BNOT"   .bdest endof
                1011 of ta" BTST:G" .bdest endof
                1100 of ta" BXOR"   .bdest endof
                1101 of ta" BNXOR"  .bdest endof
                nip unknown
        endcase ;

: src,sdest     ( operand -- ) split swap .sdest ., .dest ;
: r0x,dest      ( -- )         opcode 100 /mod .rol/roh ., dest4 ;
: src,r0x       ( -- )         opcode 100 /mod swap dest4 ., .rol/roh ;
: ssrc,sdest    ( operand -- ) split .sdest ., .dest ;
: sdest,ssrc    ( operand -- ) split swap .ldest ., .sdest ;

: extop         ( operand -- )  \ 0111010s
                split
        case    0000 of so" STE" .dest ., .abs20                endof
                0001 of so" STE" .dest ., d20" [A0]"            endof
                0010 of so" STE" .dest .,   s" [A1A0]" >$       endof
                0011 of sg" MOV" .dest .,  d8" [SP]"            endof
                0100 of sg" PUSH" .dest                         endof
                0101 of so" NEG" .dest                          endof
                0110 of so" ROT" .r1h ., .dest                  endof
                0111 of sg" NOT" .dest                          endof
                1000 of so" LDE" .abs20 ., .dest                endof
                1001 of so" LDE"  d20" [A0]," .dest             endof
                1010 of so" LDE"  s" [A1A0]," >$ .dest          endof
                1011 of sg" MOV" dup ex4 nextbyte .num8 s" [SP]," >$ (dest) endof
                1100 of sg" MOV" .imm ., .dest                  endof
                1101 of sg" POP" .dest                          endof
                1110 of so" SHL" .r1h ., .dest                  endof
                1111 of so" SHA" .r1h ., .dest                  endof
                nip unknown
        endcase ;


: moreops       ( opcode -- )   \ 11101011
                split 1000 /mod ( b0:b3 b4:b6 b7 )
      if
        case    000 of ta" SHL.L" imm4>n .# ., 0 .ldest endof
                001 of ta" SHL.L" imm4>n .# ., 1 .ldest endof
                010 of ta" SHA.L" imm4>n .# ., 0 .ldest endof
                011 of ta" SHA.L" imm4>n .# ., 1 .ldest endof
                011 and \ 1xx = INT #imm
                10000 * + ta" INT" .#
      0 endcase
      else      swap
        case    0000 of ta" LDC" .imm16 ., .sdest endof
                0001 of dup 10 and if ta" SHA.L" else ta" SHL.L" then
                        .r1h ., 1 and .ldest endof
                0010 of ta" PUSHC" .sdest endof
                0011 of ta" POPC" .sdest endof
                0100 of ta" FSET" .flag endof
                0101 of ta" FCLR" .flag endof
                ta" MOVA" .dest ., .rdest
      0 endcase
      then      ;


: ldcop         ( operand -- )
                dup 10000000 and
        if      wide if ta" STC" ssrc,sdest
                   else ta" LDC" sdest,ssrc
                   then
        else    so" XCHG" split .qsrc ., .dest
        then    ;


: dis           ( opcode -- )
                dup to opcode
        case    00000000 of s" BREAK" >$        endof
                00000100 of s" NOP" >$          endof
                01111100 of nextbyte immed2     endof
                01111101 of nextbyte immed1     endof
                01111110 of nextbyte bitop      endof
                10100010 of ta" MOV.W:S" .imm16 s" ,A0" >$      endof
                10101010 of ta" MOV.W:S" .imm16 s" ,A1" >$      endof
                11100010 of ta" MOV.B:S" .imm8  s" ,A0" >$      endof
                11101010 of ta" MOV.B:S" .imm8  s" ,A1" >$      endof
                10000010 of s" PUSH.B:S R0L" >$ endof
                10001010 of s" PUSH.B:S R0H" >$ endof
                11000010 of s" PUSH.W:S A0" >$  endof
                11001010 of s" PUSH.W:S A1" >$  endof
                10010010 of s" POP.B:S R0L" >$  endof
                10011010 of s" POP.B:S R0H" >$  endof
                11010010 of s" POP.W:S A0" >$   endof
                11011010 of s" POP.W:S A1" >$   endof
                11110010 of s" DEC.W   A0" >$   endof
                11111010 of s" DEC.W   A1" >$   endof
                10110010 of s" INC.W   A0" >$   endof
                10111010 of s" INC.W   A1" >$   endof
                11110110 of s" INTO" >$         endof
                11111110 of ta" JMP.B" .disp8   endof
                11110100 of ta" JMP.W" .disp16  endof
                11110101 of ta" JSR.W" .disp16  endof
                11110011 of s" RTS" >$          endof
                11111011 of s" REIT" >$         endof
                11111100 of ta" JMP.A" .abs20   endof
                11111101 of ta" JSR.A" .abs20   endof
                11101011 of nextbyte moreops    endof
                11101101 of ta" POPM"  nextbyte .mask endof
                11101100 of ta" PUSHM" nextbyte .mask endof
                11101110 of ta" JMPS"  .disp8   endof
                11101111 of ta" JSRS"  .disp8   endof
                11111111 of s" UND" >$          endof
                2/ \ 7-bit
                0111000 of so" MULU" src,dest   endof
                0111001 of sg" MOV" src,dest    endof
                0111010 of nextbyte extop       endof
                0111011 of nextbyte math1       endof
                0111100 of so" MUL" src,dest    endof
                0111101 of nextbyte ldcop       endof
                1000000 of so" TST" src,dest    endof
                1000100 of so" XOR" src,dest    endof
                1001000 of sg" AND"  src,dest    endof
                1001100 of sg" OR"  src,dest    endof
                1010000 of sg" ADD" src,dest    endof
                1010100 of sg" SUB" src,dest    endof
                1011000 of so" ADC" src,dest    endof
                1011100 of so" SBB" src,dest    endof
                1100000 of sg" CMP" src,dest    endof
                1100100 of so" ADD" imm4,dest   endof
                1101000 of sq" CMP" imm4,dest   endof
                1101100 of sq" MOV" imm4,dest   endof
                1110000 of so" ROT" imm41,dest   endof
                1110100 of so" SHL" imm41,dest   endof
                1111100 of so" ADJNZ" imm4,dest ., .disp8 endof
                1111000 of so" SHA" imm41,dest   endof
                2/ 2/
                00000 of   ta" MOV.B:S" r0x,dest    endof
                00001 of   ta" MOV.B:S" src,dest1   endof
                00010 of   ta" AND.B:S" src,dest1   endof
                00011 of   ta" OR.B:S"  src,dest1   endof
                00100 of   ta" ADD.B:S" src,dest1   endof
                00101 of   ta" SUB.B:S" src,dest1   endof
                00110 of   ta" MOV.B:S" src,dest1   endof
                00111 of   ta" CMP.B:S" src,dest1   endof
                01000 of   ta" BCLR:S"  bit,dsp8    endof
                01001 of   ta" BSET:S"  bit,dsp8    endof
                01010 of   ta" BNOT:S"  bit,dsp8    endof
                01011 of   ta" BTST:S"  bit,dsp8    endof
                01100 of   ta" JMP.S"  opcode disp3 endof
                01101 of   s" J" >$ opcode 111 and cond optab .disp8 endof
                10000 of   ta" ADD.B:S" imm8,dest   endof
                10001 of   ta" SUB.B:S" imm8,dest   endof
                10010 of   ta" AND.B:S" imm8,dest   endof
                10011 of   ta" OR.B:S"  imm8,dest   endof
                10100 of   ta" INC.B"   .bydest     endof
                10101 of   ta" DEC.B"   .bydest     endof
                10110 of   s" MOV.B:Z #0," >$ .bydest endof
                10111 of   ta" NOT.B:S" .bydest       endof
                11000 of   ta" MOV.B:S" imm8,dest   endof
                11001 of   ta" STZ"     imm8,dest   endof
                11010 of   ta" STNZ"    imm8,dest   endof
                11011 of   ta" STZX"    nextbyte .# ., opcode ex2 nextbyte .#
                                        ., opcode dest3 endof
                11100 of   ta" CMP.B:S" imm8,dest   endof

        endcase ;

hex
standalone [if]
: di            ( <numbers> -- )
                hex hometest
        begin   bl word count number? nip
        while   !test
        repeat  drop hometest nextbyte dis ;

: ic,           !test ;
: test          homelen . ." / " hometest nextbyte dis hometest ;
hometest
[else]
: disM16C       ( at ah  -- at' a-addr len )
\ given target address and address of actual data, returns the next
\ disassemblable address and a string
                8 to disassyDatawidth
                newout
                over to dpc       \ current disassembly pointer (target addr)
                swap - to offset  \ dpc = t   offset = h-t
                nextword dis      \ disassemble
                dpc
                outpad count ;

9 cpuid" M16C|M16C/20|M16C/60|||||"
\        0    1       2       3456         
9 new-disasm disM16C
[then]
decimal
previous definitions 

